VR-Forces Developer's Guide
 All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
railPathControllerPSR.h
Go to the documentation of this file.
1 /*******************************************************************************
2 ** Copyright (c) 2015 MAK Technologies, Inc.
3 ** All rights reserved.
4 *******************************************************************************/
5 
8 
9 #pragma once
10 
12 #include "vrfobjcore/simObject.h"
13 #include "readerWriter/rwVector.h"
14 #include <readerWriter/rwString.h>
15 #include <readerWriter/rwInt.h>
17 #include "vrfutil/rwRailSegment.h"
18 #include <vrfutil/rwUUID.h>
20 
26 
29 {
30 public:
33  const DtString& rwName = DtString::nullString(),
34  DtReaderWriterRegistry* parentRegistry = 0);
35 
38  const DtString& rwName = DtString::nullString(),
39  DtReaderWriterRegistry* parentRegistry = 0);
40 
42  virtual ~DtRailPathControllerPSR();
43 
46 
49  const DtString& rwName = DtString::nullString(),
50  DtReaderWriterRegistry* parentRegistry = 0) const;
51 
53  virtual DtString type() const;
54 
55  virtual void clear();
56 
57  virtual void clearPath();
58 
61  virtual const DtRwRailSegmentList& pathList() const;
62  virtual DtRwRailSegmentList& pathList();
63  virtual void addSegmentToPath(const DtRailSegment& seg,bool appendToEnd = true);
64  virtual void addRailSegments(DtRailSegmentList*);
66 
70  virtual void setDestination(const DtUUID& destination);
71 
73  virtual DtSimObjectReference destination() const;
74 
76  virtual bool destinationSpecified() const;
78  virtual void unspecifyDestination();
80 
84  virtual void setDestinationLocation(const DtVector& destinationLocation);
85  virtual DtVector destinationLocation() const;
87  virtual bool destinationLocationSpecified() const;
89  virtual void unspecifyDestinationLocation();
91 
96  virtual void setDebugPath(const DtUUID&);
97 
100  virtual const DtRwSimObjectReference& debugPath() const;
102  virtual bool debugPathSpecified() const;
104  virtual void unspecifyDebugPath();
106 
107 public:
108 
110  static DtVrfProcessStateRepository* creator (const DtString& rwName,
111  DtLocalObject* vrfObject, DtReaderWriterRegistry* parentRegistry);
112 
113 protected:
114 
123 
133 };
UUID is a unique ID wrapper class.
Definition: uuid.h:59
File: rwRailSegment.h.
std::list< DtRailSegment * > DtRailSegmentList
Definition: railSegment.h:197
DtRailSegment are segments entities can follow when using the rail movement system.
Definition: railSegment.h:23
The DtSimObjectReference is a shared pointer that can be used amongst many object for access to the u...
Definition: simObjectReference.h:26
Definition: readerWriterRegistry.h:39
Contains the DtUUID class declaration.
DtRwVector myDestinationLocation
Parameter Name: destination-location Parameter Description: Stores the geocentric location of the des...
Definition: railPathControllerPSR.h:129
Definition: rwVector.h:23
Specialized reader/writer version of the shared object reference that will encapsulate the actual sha...
Definition: rwSimObjectReference.h:21
#define DT_DLL_vrfobjcore
This file is used to determine how to build.
Definition: vrfobjcoreDefines.h:24
virtual DtVrfProcessStateRepository * clone(const DtString &rwName=DtString::nullString(), DtReaderWriterRegistry *parentRegistry=0) const =0
DtRwSimObjectReference myDestination
Parameter Name: destination-name Parameter Description: Stores the name of the destination object if ...
Definition: railPathControllerPSR.h:126
class DtRailPathControllerPSR:
Definition: railPathControllerPSR.h:28
Class DtVrfProcessStateRepository: Abstract base class for all process state repositories. Process state repositories represent (potentially) shared, savable information for one or more components functioning together to achieve some process or set of processes; such as aiming and firing a weapon; moving an object; or just waiting a specified amount of time.
Definition: vrfProcessStateRepository.h:45
virtual DtString type() const =0
Returns the string type of the repository, as defined in procSRTypes.h.
DtRwSimObjectReference myDebugPath
Parameter Name: destination-name Parameter Description: Stores the name of the destination object if ...
Definition: railPathControllerPSR.h:122
DtRwRailSegmentList myPathList
Parameter Name: path Parameter Description: Stores the calculated rail path .
Definition: railPathControllerPSR.h:132
File: rwVector.h.
const DtVrfProcessStateRepository & operator=(const DtVrfProcessStateRepository &orig)
A locally simulated VRF object. Holds all internal and external data for the object, and provides access to both the current frame and next frame state data for the object. All current frame data is read-only, and next-frame data can be written to. No thread safety guarantees are made on this object during the simulation frame and it should only be accessed by the thread that is simulating the object.
Definition: localObject.h:86

Document ID: Generated on Tue Sep 24 19:28:17 EDT 2024 from SVN revision 269799
Copyright © 2005-2024 MAK Technologies. All Rights Reserved (www.mak.com)